<!doctype html>
<html lang="es">

<head>
  <meta charset='utf-8'>
  <title>Estilos: Pseudo selectores</title>
  <link rel='stylesheet' href='css/style.css'>
  <link rel='stylesheet' href='css/print.css' media='print'>
</head>

<body>


  <article class='reveal'>

    <section data-bespoke-state='portada'>
      <h1>Estilos: Pseudo selectores</h1>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Pseudo-clases</h2>
      <ul class="lista">
        <li>Suelen referirse a estados de un elemento</li>
        <li>Empiezan por <strong>:</strong></li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="selector">:hover</span></h2>
      <ul class="lista">
        <li>Se aplica a los elementos con el ratón sobre ellos</li>
        <li>A la etiqueta en la que estés y sus ancestros</li>
        <li>Poco sentido en móvil</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <div>
          <h4>css:</h4>
          <pre><code><span class="selector">li:hover</span> {
  <span class="propiedad">border:</span> <span class="valor-css">1px solid;</span>
}</code></pre>
        </div>
        <iframe src="ejemplos/p17_hover.html"></iframe>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="selector">:active</span></h2>
      <ul class="lista">
        <li>Se aplica cuando se está pulsando los elementos</li>
        <li>A la etiqueta en la que estés y sus ancestros</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <div>
          <h4>css:</h4>
          <pre><code><span class="selector">.boton:active</span> {
  <span class="propiedad">background-color:</span> <span class="valor-css">#b8b8b8;</span>
}</code></pre>
        </div>
        <iframe src="ejemplos/p17_active.html"></iframe>
      </div>
    </section>

    <section class="no-print" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Crear una página que al menos tenga cabecera, menú y unas secciones enlazadas desde el menú</li>
        <li>Menú con enlaces
          <ul>
            <li>Los enlaces tiene que aparecer centrados, separados entre ellos y con un padding</li>
            <li>Que al posicionarse sobre ellos cambie el estilo, por ejemplo, fondo más claro y borde.</li>
            <li>Que al posicionarse pulsar sobre ellos cambie el estilo, por ejemplo, fondo más claro aún.</li>
          </ul>
        </li>
      </ul>
      <p class="text-center">
        <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio30/img/resultado.png?inline=false">Ejemplo</a>
      </p>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="selector">:focus</span></h2>
      <ul class="lista">
        <li>Se aplica cuando un elemento tiene el cursor sobre el</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <div>
          <h4>css:</h4>
          <pre><code><span class="selector">input:focus</span> {
  <span class="propiedad">border:</span> <span class="valor-css">2px solid #8cb3db;</span>
}</code></pre>
        </div>
        <iframe src="ejemplos/p17_focus.html"></iframe>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="selector">:link</span></h2>
      <ul class="lista">
        <li>Se aplica a los enlaces no visitados</li>
      </ul>
      <h2><span class="selector">:visited</span></h2>
      <ul class="lista">
        <li>Se aplica a los enlaces visitados</li>
      </ul>
      <h3>Ejemplos</h3>
      <div class="columnas-flex">
        <div>
          <h4>css:</h4>
          <pre><code><span class="selector">a:link</span> {
  <span class="propiedad">color:</span> <span class="valor-css">blue;</span>
}
<span class="selector">a:visited</span> {
  <span class="propiedad">color:</span> <span class="valor-css">magenta;</span>
}</code></pre>
        </div>
        <iframe src="ejemplos/p17_link_visited.html"></iframe>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="selector">:checked</span></h2>
      <ul class="lista">
        <li>Identifica los elementos seleccionados</li>
      </ul>
      <h3>Ejemplos</h3>
      <div class="columnas-flex">
        <div>
          <h4>css:</h4>
          <pre><code><span class="selector">input:checked + label</span> {
  <span class="propiedad">color:</span> <span class="valor-css">green;</span>
}</code></pre>
        </div>
        <iframe src="ejemplos/p17_checked.html"></iframe>
      </div>
    </section>

    <section class="no-print" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Partiendo del ejercicio anterior.</li>
        <li>Reemplazar los enlaces por labels</li>
        <li>Poner casillas de opción <input type="radio"> justo antes de cada sección</li>
        <li>Hacer que las secciones estén ocultas por defecto</li>
        <li>Mostrar la sección que tenga una casilla de opción seleccionada justo antes</li>
        <li>Ocultar las casillas de opción</li>
      </ul>
      <p class="text-center">
        <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio31/img/resultado.png?inline=false">Ejemplo</a>
      </p>
    </section>

    <section data-bespoke-state='clean'>
      <h2>De formulario</h2>
      <ul class="lista">
        <li><span class="selector">:required</span>, elementos obligatorios</li>
        <li><span class="selector">:optional</span>, elementos opcionales</li>
        <li><span class="selector">:invalid</span>, elementos con valores no válidos</li>
        <li><span class="selector">:valid</span>, elementos con valores válidos</li>
      </ul>
      <h3>Ejemplos</h3>
      <div class="columnas-flex">
        <div>
          <h4>css:</h4>
          <pre><code><span class="selector"><span class="selector">:required</span> {
    <span class="propiedad">border:</span> <span class="valor-css">2px solid;</span>
}
<span class="selector">:invalid</span> {
    <span class="propiedad">border-color:</span> <span class="valor-css">red;</span>
}
<span class="selector">:valid</span> {
    <span class="propiedad">border:</span> <span class="valor-css">1px solid #ced4da;</span>
}</code></pre>
        </div>
        <iframe src="ejemplos/p17_formulario.html"></iframe>
      </div>      
    </section>

    <section data-bespoke-state='clean'>
      <h2>Pseudo-elemento</h2>
      <ul class="lista">
        <li>Suelen referirse a partes de un elemento</li>
        <li>Empiezan por <strong>::</strong></li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="selector">::first-line</span></h2>
      <ul class="lista">
        <li>Permite aplicar estilo distinto a la primera línea</li>
      </ul>
      <h2><span class="selector">::first-letter</span></h2>
      <ul class="lista">
        <li>Permite aplicar estilo distinto a la primera letra</li>
      </ul>
      <h3>Ejemplos</h3>
      <div class="columnas-flex">
        <div>
          <h4>css:</h4>
          <pre><code><span class="selector"><span class="selector">::first-line</span> {
  <span class="propiedad">font-weight</span> <span class="valor-css">bold;</span>
}
<span class="selector">::first-letter</span> {
  <span class="propiedad">float:</span> <span class="valor-css">left;</span>
  <span class="propiedad">font-family:</span> <span class="valor-css">cursive;</span>
  <span class="propiedad">font-size:</span> <span class="valor-css">3em;</span>
}</code></pre>
        </div>
        <iframe src="ejemplos/p17_first_line_letter.html"></iframe>
      </div> 
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="selector">::before</span></h2>
      <ul class="lista">
        <li>Permite seleccionar la sección anterior a un elemento</li>
      </ul>
      <h2><span class="selector">::after</span></h2>
      <ul class="lista">
        <li>Permite seleccionar la sección posterior a un elemento</li>
      </ul>
      <h3><span class="propiedad">content</span></h3>
      <ul class="lista">
        <li>Permite introducir contenido</li>
        <li>Para introducir texto: <span class="valor-css">"texto"</span></li>
        <li>Para introducir imágenes: <span class="valor-css">url("direccion")</span></li>
        <li>El contenido introducido no se puede copiar</li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Ejemplos</h2>
      <div class="columnas-flex">
        <div>
          <h4>css:</h4>
          <pre><code><span class="selector">.documento::before</span> {
    <span class="propiedad">content:</span> <span class="valor-css">url("../img/page.png");</span>
}
<span class="selector">.etiqueta::before</span> {
    <span class="propiedad">font-weight:</span> <span class="valor-css">bold;</span>
    <span class="propiedad">content:</span> <span class="valor-css">"<";</span>
}
<span class="selector">.etiqueta::after</span> {
    <span class="propiedad">font-weight:</span> <span class="valor-css">bold;</span>
    <span class="propiedad">content:</span> <span class="valor-css">">";</span>
}
<span class="selector">.btn-check::before</span> {
    <span class="propiedad">font-family:</span> <span class="valor-css">bootstrap-icons;</span>
    <span class="propiedad">content:</span> <span class="valor-css">"\F26E";</span>
}</code></pre>
        </div>
        <div>
          <iframe src="ejemplos/p17_before_after.html"></iframe>
          <div>
            <h3>Botones con iconos</h3>
            <ul class="lista">
              <li>Los botones <span class="etiqueta">input</span> no admiten</li>
              <li>Necesitamos <span class="etiqueta">button</span></li>
            </ul>
            <pre><code><span class="etiqueta">button <span class="propiedad">class=</span><span class="valor">"btn-check"</span></span>Enviar<span class="etiqueta">/button</span></code></pre>
          </div>
        </div>
      </div> 
    </section>

    <section data-bespoke-state='clean'>
      <h2>Tip: <span class="propiedad">box-sizing</span></h2>
      <ul class="lista">
        <li>Resetea el box-sizing asignanando <span class="propiedad">border-box</span> a todo</li>
        <li>Permite que los componentes lo cambien</li>
      </ul>
      <pre><code><span class="selector">html</span> {
  <span class="propiedad">box-sizing:</span> <span class="valor-css">border-box;</span>
}
<span class="selector">*</span>, <span class="selector">*:before</span>, <span class="selector">*:after</span> {
  <span class="propiedad">box-sizing:</span> <span class="valor-css">inherit;</span>
}</code></pre>
    </section>

    <section class="no-print" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Hacer que el formulario muestre a simple vista los campos con error:
          <ul>
            <li>Los obligatorios con un borde de 2px</li>
            <li>Los errores con un borde de 1px</li>
          </ul>
        </li>
        <li>Cuando un control tenga el foco poner un borde de otro color</li>
        <li>Añadir un icono a cada botón</li>
      </ul>
      <p class="text-center">
        <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio32/img/resultado.png?inline=false">Resultado</a>
      </p>
    </section>

  </article>

  <script src='js/slides.keys.js'></script>
  <script src='js/slides.classes.js'></script>
  <script src='js/slides.state.js'></script>
  <script src='js/slides.kernel.js'></script>
  <script src='js/slides.jump.js'></script>
  <script src='js/slides.swipe.js'></script>

  <script>
    const { Deck, classes, keys, state, jump, swipe } = S6;
    const deck = new Deck({
      parent: 'article',
      plugins: [classes(), keys(), state(), jump(), swipe()]
    });
  </script>
</body>

</html>